#ifndef Factory_h__
#define Factory_h__

#include "Config.h"
#include "Entity.h"
#include "CAnimation.h"
#include "CPosition.h"
#include "CController.h"

class Factory
{
public:
	// To create and return an Entity.
	// @param entityID: The ID to specify the Entity gonna create.
	Entity* create(ID::Entity entityID);

	static Factory* getInstance();

	// Must be call before use this Factory.
	static void init();

	// Call to release this Factory.
	static void release();

private:
	Factory();
	~Factory();

	// The list of method used to create each type of Entity.
	// Sorted by A->Z.
	Entity* create_STDIO_LOGO();
	Entity* create_STDIO_LOGO_CONTROLABLE();

private:
	static Factory* m_instance;
};

#endif // Factory_h__
