#include "Manager.h"
#include "CAnimation.h"
#include "CPosition.h"

ManagerCAnimation* ManagerCAnimation::m_instance = nullptr;

ManagerCAnimation::ManagerCAnimation()
{
	m_componentList.clear();
}

ManagerCAnimation::~ManagerCAnimation()
{}

void ManagerCAnimation::release()
{
	SAFE_DELETE(m_instance);
}

void ManagerCAnimation::init()
{
	m_instance = new ManagerCAnimation();
}

ManagerCAnimation* ManagerCAnimation::getInstance()
{
	return m_instance;
}

void ManagerCAnimation::removeComponent(CAnimation* component)
{
	for (int i = 0; i < m_componentList.size(); ++i)
	{
		if (m_componentList.at(i) == component)
		{
			m_componentList.erase(m_componentList.begin() + i);
			i--;
		}
	}
}

void ManagerCAnimation::addComponent(CAnimation* component)
{
	m_componentList.push_back(component);
}

void ManagerCAnimation::callDraw(HDC hdc)
{
	for each (CAnimation* component in m_componentList)
	{
		try
		{
			Vector2 drawPos = *component->getOwner()->getProperty(ID::COMPONENT::POSITION, CPosition::PropertyFlag::PFLAG_POSITION).ptrVector2;
			component->draw(hdc, drawPos);
		}
		catch (exception e)
		{
			OUTPUT("Entity::draw\nCannot draw\n" << std::string(e.what()) << endl);
		}
	}
}