#ifndef Manager_h__
#define Manager_h__

#include "stdafx.h"
#include <vector>

class CAnimation;
class ManagerCAnimation
{
public:
	// To call the draw method from all created CAnimation.
	// @param hdc: Handle for Device Context using in this draw.
	void callDraw(HDC hdc);

	// To add a new-created CAnimation into managing list.
	// @param component: Pointer to the pushed component.
	void addComponent(CAnimation* component);

	// To remove the passed component from managing list, treated as destroyed.
	// @param component: Pointer to the released component.
	void removeComponent(CAnimation* component);

	// Singleton Pattern methods
	static ManagerCAnimation* getInstance();
	static void init();
	static void release();
	// ========================

private:
	ManagerCAnimation();
	~ManagerCAnimation();

private:
	std::vector<CAnimation*> m_componentList;
	static ManagerCAnimation* m_instance;
};

#endif // Manager_h__
