#include "stdafx.h"
#include "..\resource.h"
#include "FWindows.h"
#include "FTexture.h"

#include "Entity.h"
#include "Factory.h"
#include "Manager.h"

void init(HINSTANCE instance, HWND handler);
void release();
void update(float delta);
void draw(HDC hdc);

Entity* g_entity1;
Entity* g_entity2;

int APIENTRY _tWinMain(_In_ HINSTANCE hInstance,
	_In_opt_ HINSTANCE hPrevInstance,
	_In_ LPTSTR    lpCmdLine,
	_In_ int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);
	FWindows window(hInstance, nCmdShow, 500, 500, &update, &draw);

	init(hInstance, window.getHandler());

	window.run();
	
	release();

	return 0;
}

// UPDATE REGION
void update(float delta)
{
	g_entity1->update(delta);
	g_entity2->update(delta);
}

// DRAW REGION
void draw(HDC hdc)
{
	ManagerCAnimation::getInstance()->callDraw(hdc);
}

void init(HINSTANCE instance, HWND handler)
{
	FTexture::init(instance, handler);
	Factory::init();
	ManagerCAnimation::init();

	g_entity1 = Factory::getInstance()->create(ID::STDIO_LOGO);
	g_entity2 = Factory::getInstance()->create(ID::STDIO_LOGO_CONTROLABLE);
}

void release()
{
	FTexture::release();
	Factory::release();
	ManagerCAnimation::release();

	SAFE_DELETE(g_entity1);
	SAFE_DELETE(g_entity2);
}
